
(function($) {
	$.fn.slideshowpro = function(options){
		var defaults = {
			max_item_display	: 1,				// number item display in navigation bar
			distance			: 0,				// distance slide navigation bar,
			random_time			: "",				// to create instance ID
			max_sub_item		: 6,				// number sub item display each page, to pagging
			total_item			: 1,				// total item
			style				: "images",			// number or images
			align_image			: "left"			// align of main images
		};
		
		var options 	= $.extend(defaults, options);
		
		
		function navigation_click(){
			$("ul li",control_bar).each(function(index){
				$(this).bind("click",function(){
					cur_index	= index;

					if ( (index==last_item && index!=number_item && options.max_item_display > 2) || (index>last_item && index!=number_item && options.max_item_display == 2) ){
						last_item++;
						first_item++;
						
						control_bar.animate({
							left: "-="+options.distance
						}, 500, function() {});
					}else if (index==first_item && index!=0){
						last_item--;
						first_item--;
						control_bar.animate({
							left: "+="+options.distance
						}, 500, function() {});
					}
					
					change_infor(index);
				});
			});
		}
		
		function next_click(){
		
			if (!slide_running){
				cur_index++;
				if (options.style=="images"){
					if ( (cur_index>last_item && cur_index<number_item && options.max_item_display ==2 ) || (cur_index==last_item && cur_index<number_item && options.max_item_display > 2) || (cur_index==number_item && last_item <number_item) ) {
						last_item++;
						first_item++;
						control_bar.animate({
							left: "-="+options.distance
						}, 500, function() {});
					}else if (cur_index>number_item){
						first_item		= 0;
						last_item		= options.max_item_display -1;
						cur_index		= 0;
						control_bar.animate({
							left: 0
						}, 500, function() {});
					}
				}else if (options.style=="number"){
					if (cur_index>number_item)
						cur_index	= 0;
					$(".number_page",root).text((cur_index+1)+"/"+(number_item+1));
					$("div.navigation_number span.title",root).text(titles.eq(cur_index).text());
				}else{
					if (cur_index>number_item)
						cur_index	= 0;
					root.find("div.small_button .active").removeClass("active");
					$("div.small_button .bullet_button:eq("+cur_index+")",root).addClass("active");
				}
				
				//Change infor
				change_infor(cur_index);
				
			}
		}
		
		function previous_click(){
			if (!slide_running){
			
				cur_index--;
				if (options.style=="images"){
					if ( (cur_index<=first_item && cur_index>0)  ){
						last_item--;
						first_item--;
						control_bar.animate({
							left: "+="+options.distance
						}, 500, function() {});
					}else if (cur_index<0){
						first_item		= number_item - options.max_item_display +1 ;
						last_item		= number_item;
						// //fix cho truong hop options.max_item_display=2
						// if (first_item==last_item-1)
							// first_item--;
						cur_index		= number_item;
						control_bar.animate({
							left: -(number_item - options.max_item_display +1)*options.distance
						}, 500, function() {});
					}
				}else if (options.style=="number"){
					if (cur_index<0)
						cur_index	= number_item;
					$(".number_page",root).text((cur_index+1)+"/"+(number_item+1));
					$("div.navigation_number span.title",root).text(titles.eq(cur_index).text());
				}else{
					if (cur_index<0)
						cur_index	= number_item;
					root.find("div.small_button .active").removeClass("active");
					$("div.small_button .bullet_button:eq("+cur_index+")",root).addClass("active");
				}
				
				//Change infor
				change_infor(cur_index);
				
			}
		}
		
		function pagging_product(obj){
			var index_item	= obj.index();
			obj.parent().find(".page_active").removeClass("page_active");
			obj.addClass("page_active");
			obj.parent().parent().find(".icon_product").css("display","none");
			obj.parent().parent().find(".icon_product").filter(function(index) {
				return (index >= index_item*options.max_sub_item) && (index < (index_item+1)*options.max_sub_item);
			}).css('display', 'block');
			
			resize_height_desc(obj);
		}
		
		//Change infor
		function change_infor(index_item){
			$(".info_product",root).removeClass("info_product_active");
			$(".info_product",root).filter(function (int_d) {
				return int_d == index_item;
			}).addClass("info_product_active");
			
			$(".product_item",root).removeClass("item_active");
			
			$($(".info_product",root).eq(index_item)).find(".product_item").filter(":first").addClass("item_active");
			
			//Resize height of description when change infor
			infor_active	= $(".info_product_active",root);
			$(".intro_product",infor_active).css("height",infor_active.height() - $(".images_product",infor_active).height());
		}
		
		//Resize height of description when change page active
		function resize_height_desc(obj){
			var infor_height	= obj.parent().parent().parent().parent().height() - $(".images_product",obj.parent().parent().parent().parent()).height();
			$(".intro_product",obj.parent().parent().parent().parent()).css("height",infor_height);
		}
		
		var root			= $(this);
		var first_item		= 0;
		var last_item		= options.max_item_display -1;
		var cur_index		= 0;
		var control_bar		= $(".navigation_sspro",this);
		var number_item		= options.total_item-1;
		var image_width		= $("#slider"+options.random_time,this).width();
		var image_height	= $("#slider"+options.random_time,this).height();
		var titles 			= root.find('.title_product_tooltip');
		
		var running			= false;
		
		return this.each(function() {
			if (options.style=="bullets"){
				if (options.align_image=="left"){
					$(".navigation_button",root).css("left",(root.width()-$(".info_product",root).width()-$(".navigation_button",root).width())/2);
				}else{
					$(".navigation_button",root).css("right",(root.width()-$(".info_product",root).width()-$(".navigation_button",root).width())/2);
				}
			}
			
			navigation_click();
			
			$(".right_button",this).bind("click",function(){
				next_click();
			});
			
			$(".left_button",this).bind("click",function(){
				previous_click();
			});
			
			$(".pagging_button",this).each(function(){
				//first active
				if ($(this).hasClass("page_active")){
					pagging_product($(this));
				}
				
				$(this).bind("click",function(){
					pagging_product($(this));
				});
			});
			
			$(".bullet_button",this).each(function(index){
				$(this).bind("click",function(){
					if ($(this).hasClass("active")) return false;
					cur_index	= index;
					$(this).parent().find(".active").removeClass("active");
					$(this).addClass("active");
					
					//Change infor
					change_infor(index);

				});
				
				$(this).bind("mouseover",function(){
					if ($(this).hasClass("active")) return false;
					$(".text_tooltip",root).text(titles.eq(index).text());
					$(".sspro_tooltip",root).css({
						left	: $(this).position().left +7 - $(".sspro_tooltip",root).width()/2,
						display	: "block"
					});
				});
				
				$(this).bind("mouseout",function(){
					$(".sspro_tooltip",root).css("display","none");
				});
			});
			
			// $(".product_item",this).each(function(){
			(root).find(".product_item").each(function(){
				$(this).bind("click",function(){
					
					if ($(this).hasClass("item_active")) return false;
					
					if (running) return false;
					
					running	= true;
					
					$(this).parent().parent().find(".item_active").removeClass("item_active");
					$(this).addClass("item_active");
					var url_image	= "http://"+document.domain+$(this).attr("alt");
					
					// $("#slider"+options.random_time,root).css("background","none");
					// $("#slider"+options.random_time,root).fadeOut(500);
					
					//check exits #wrapperImage and append to document
					if ($("#wrapperImage"+options.random_time,root).length == 0) {
						if (options.align_image=="left"){
							$('<div/>', {
								id: 'wrapperImage'+options.random_time
							}).css({
								background: $("#slider"+options.random_time,root).css("background-image")+" no-repeat",
								position:'relative',
								top:0,
								left:0,
								height:  image_height
							}).appendTo($("#slider"+options.random_time,root));
						}else{
							$('<div/>', {
								id: 'wrapperImage'+options.random_time
							}).css({
								background: $("#slider"+options.random_time,root).css("background-image")+" no-repeat right top",
								position: 'absolute',
								top: 0,
								right: 0,
								height:  image_height,
								width:  image_width
							}).appendTo($("#slider"+options.random_time,root));
							
							// $("#slider"+options.random_time,root).css({
								// background	: "url('"+url_image+"') no-repeat right top"
							// });
						}
					}
					
					$("#wrapperImage"+options.random_time,root).css({
						opacity		: 1
					});
					
					if (options.align_image=="left"){
						$("#slider"+options.random_time,root).css({
							background	: "url('"+url_image+"') no-repeat"
						});
					}else{
						$("#slider"+options.random_time,root).css({
							background	: "url('"+url_image+"') no-repeat right top"
						});
					}
					
					$("#wrapperImage"+options.random_time,root).animate({
						opacity: 0
					}, 800, function() {
						
						$("#wrapperImage"+options.random_time,root).empty();
						
						if (options.align_image=="left"){
							$("#wrapperImage"+options.random_time,root).css({
								background: "url('"+url_image+"') no-repeat",
								width: image_width,
								height: image_height
							});
						}else{
							$("#wrapperImage"+options.random_time,root).css({
								background: "url('"+url_image+"') no-repeat right top",
								width: image_width,
								height: image_height
							});
						}
						
						running	= false;
					});
					
					
				});
			});
		});
	}
	
})($jsmart||jQuery);

